<?xml version="1.0"?>
<inputList>
  <!-- Keyboard -->
  <inputConfig type="keyboard" deviceName="Keyboard" deviceGUID="-1" deviceNbAxes="0" deviceNbHats="0" deviceNbButtons="120">
    <input name="a" type="key" id="115" value="1" code="168" />
    <input name="b" type="key" id="97" value="1" code="168" />
    <input name="down" type="key" id="1073741905" value="1" code="168" />
    <input name="hotkey" type="key" id="32" value="1" code="168" />
    <input name="left" type="key" id="1073741904" value="1" code="168" />
    <input name="pagedown" type="key" id="1073741902" value="1" code="168" />
    <input name="pageup" type="key" id="1073741899" value="1" code="168" />
    <input name="right" type="key" id="1073741903" value="1" code="168" />
    <input name="select" type="key" id="32" value="1" code="168" />
    <input name="start" type="key" id="13" value="1" code="168" />
    <input name="up" type="key" id="1073741906" value="1" code="168" />
  </inputConfig>
  <!-- MIROOF VIRTUAL GAMEPADS -->
  <inputConfig type="joystick" deviceName="Virtual gamepad" deviceGUID="03000000030000000300000002000000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="8">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="6" value="1" code="314" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="5" value="1" code="311" />
    <input name="pageup" type="button" id="4" value="1" code="310" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="6" value="1" code="314" />
    <input name="start" type="button" id="7" value="1" code="315" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="2" value="1" code="307" />
    <input name="y" type="button" id="3" value="1" code="308" />
  </inputConfig>
  <!-- Nes30 Pro BT -->
  <inputConfig type="joystick" deviceName="8Bitdo NES30 Pro" deviceGUID="05000000c82d00002038000000010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="13" value="1" code="317" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="button" id="8" value="1" code="312" />
    <input name="l3" type="button" id="13" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="r2" type="button" id="9" value="1" code="313" />
    <input name="r3" type="button" id="14" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- SN30 Pro USB -->
  <inputConfig type="joystick" deviceName="8Bitdo SN30 Pro  8Bitdo SN30 Pro" deviceGUID="03000000c82d00000160000011010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="15">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="13" value="1" code="317" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="button" id="8" value="1" code="312" />
    <input name="l3" type="button" id="13" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="r2" type="button" id="9" value="1" code="313" />
    <input name="r3" type="button" id="14" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- Nes30 Pro USB -->
  <inputConfig type="joystick" deviceName="8Bitdo NES30 Pro   8Bitdo NES30 Pro" deviceGUID="03000000c82d00000190000011010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="15">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="13" value="1" code="317" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="button" id="8" value="1" code="312" />
    <input name="l3" type="button" id="13" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="r2" type="button" id="9" value="1" code="313" />
    <input name="r3" type="button" id="14" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- SF30 Pro BT -->
  <inputConfig type="joystick" deviceName="8Bitdo SF30 Pro" deviceGUID="05000000c82d00000061000000010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="2" value="1" code="306" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="button" id="8" value="1" code="312" />
    <input name="l3" type="button" id="13" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="r2" type="button" id="9" value="1" code="313" />
    <input name="r3" type="button" id="14" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- FC30 Pro BT -->
  <inputConfig type="joystick" deviceName="8Bitdo FC30 Pro" deviceGUID="05000000c82d00001038000000010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="13" value="1" code="317" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="axis" id="5" value="-1" code="10" />
    <input name="l3" type="button" id="13" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="r2" type="axis" id="4" value="-1" code="9" />
    <input name="r3" type="button" id="14" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- Zero GamePad BT -->
  <inputConfig type="joystick" deviceName="8Bitdo Zero GamePad" deviceGUID="05000000a00500003232000009010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="10" value="1" code="314" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="4" value="1" code="308" />
    <input name="y" type="button" id="3" value="1" code="307" />
  </inputConfig>
  <!-- Zero GamePad BT (2nd)-->
  <inputConfig type="joystick" deviceName="8Bitdo Zero GamePad" deviceGUID="05000000a00500003232000001000000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="12" value="1" code="305" />
    <input name="b" type="button" id="11" value="1" code="304" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="21" value="1" code="314" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="18" value="1" code="311" />
    <input name="pageup" type="button" id="17" value="1" code="310" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="21" value="1" code="314" />
    <input name="start" type="button" id="22" value="1" code="315" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="15" value="1" code="308" />
    <input name="y" type="button" id="14" value="1" code="307" />
  </inputConfig>
  <!-- iBuffalo Classic USB Gamepad -->
  <inputConfig type="joystick" deviceName="USB,2-axis 8-button gamepad  " deviceGUID="03000000830500006020000010010000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="8">
    <input name="a" type="button" id="0" value="1" code="288" />
    <input name="b" type="button" id="1" value="1" code="289" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="6" value="1" code="294" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="5" value="1" code="293" />
    <input name="pageup" type="button" id="4" value="1" code="292" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="6" value="1" code="294" />
    <input name="start" type="button" id="7" value="1" code="295" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="2" value="1" code="290" />
    <input name="y" type="button" id="3" value="1" code="291" />
  </inputConfig>
  <!-- Nes30 Arcade BT -->
  <inputConfig type="joystick" deviceName="8Bitdo             8Bitdo NES30 Arcade" deviceGUID="03000000c82d00000310000011010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="12">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="10" value="1" code="314" />
    <input name="l2" type="button" id="6" value="1" code="310" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="9" value="1" code="313" />
    <input name="pageup" type="button" id="7" value="1" code="311" />
    <input name="r2" type="button" id="8" value="1" code="312" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="4" value="1" code="308" />
    <input name="y" type="button" id="3" value="1" code="307" />
  </inputConfig>
  <inputConfig type="joystick" deviceName="8Bitdo NES30 Arcade" deviceGUID="05000000c82d00008010000000010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="10" value="1" code="314" />
    <input name="l2" type="button" id="6" value="1" code="310" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="9" value="1" code="313" />
    <input name="pageup" type="button" id="7" value="1" code="311" />
    <input name="r2" type="button" id="8" value="1" code="312" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="4" value="1" code="308" />
    <input name="y" type="button" id="3" value="1" code="307" />
  </inputConfig>
  <!-- SFC30 USB -->
  <inputConfig type="joystick" deviceName="8Bitdo SFC30 GamePad" deviceGUID="05000000c82d00003028000000010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="10" value="1" code="314" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- SFC30 BT -->
  <inputConfig type="joystick" deviceName="SFC30              SFC30 Joystick" deviceGUID="03000000c82d000021ab000010010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="12">
    <input name="a" type="button" id="0" value="1" code="288" />
    <input name="b" type="button" id="1" value="1" code="289" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="10" value="1" code="298" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="7" value="1" code="295" />
    <input name="pageup" type="button" id="6" value="1" code="294" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="10" value="1" code="298" />
    <input name="start" type="button" id="11" value="1" code="299" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="3" value="1" code="291" />
    <input name="y" type="button" id="4" value="1" code="292" />
  </inputConfig>
  <!-- Generic USB -->
  <inputConfig type="joystick" deviceName="Twin USB Joystick" deviceGUID="03000000100800000100000010010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="12">
    <input name="a" type="button" id="1" value="1" code="289" />
    <input name="b" type="button" id="2" value="1" code="290" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="10" value="1" code="298" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="3" value="-1" code="5" />
    <input name="joystick2up" type="axis" id="2" value="-1" code="2" />
    <input name="l2" type="button" id="4" value="1" code="292" />
    <input name="l3" type="button" id="10" value="1" code="298" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="7" value="1" code="295" />
    <input name="pageup" type="button" id="6" value="1" code="294" />
    <input name="r2" type="button" id="5" value="1" code="293" />
    <input name="r3" type="button" id="11" value="1" code="299" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="296" />
    <input name="start" type="button" id="9" value="1" code="297" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="0" value="1" code="288" />
    <input name="y" type="button" id="3" value="1" code="291" />
  </inputConfig>
  <!-- PS3 BT -->
  <inputConfig type="joystick" deviceName="PLAYSTATION(R)3 Controller" deviceGUID="050000004c0500006802000000800000" deviceNbAxes="6" deviceNbHats="0" deviceNbButtons="17">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="button" id="14" value="1" code="545" />
    <input name="hotkey" type="button" id="10" value="1" code="316" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="3" value="-1" code="3" />
    <input name="joystick2up" type="axis" id="4" value="-1" code="4" />
    <input name="l2" type="button" id="6" value="1" code="312" />
    <input name="l3" type="button" id="11" value="1" code="317" />
    <input name="left" type="button" id="15" value="1" code="546" />
    <input name="pagedown" type="button" id="5" value="1" code="311" />
    <input name="pageup" type="button" id="4" value="1" code="310" />
    <input name="r2" type="button" id="7" value="1" code="313" />
    <input name="r3" type="button" id="12" value="1" code="318" />
    <input name="right" type="button" id="16" value="1" code="547" />
    <input name="select" type="button" id="8" value="1" code="314" />
    <input name="start" type="button" id="9" value="1" code="315" />
    <input name="up" type="button" id="13" value="1" code="544" />
    <input name="x" type="button" id="2" value="1" code="307" />
    <input name="y" type="button" id="3" value="1" code="308" />
  </inputConfig>
  <!-- PS4 USB -->
  <inputConfig type="joystick" deviceName="Sony Computer Entertainment Wireless Controller" deviceGUID="030000004c050000c405000011810000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="13">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="10" value="1" code="316" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="3" value="-1" code="3" />
    <input name="joystick2up" type="axis" id="4" value="-1" code="4" />
    <input name="l2" type="button" id="6" value="1" code="312" />
    <input name="l3" type="button" id="11" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="5" value="1" code="311" />
    <input name="pageup" type="button" id="4" value="1" code="310" />
    <input name="r2" type="button" id="7" value="1" code="313" />
    <input name="r3" type="button" id="12" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="314" />
    <input name="start" type="button" id="9" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="2" value="1" code="307" />
    <input name="y" type="button" id="3" value="1" code="308" />
  </inputConfig>
  <!-- PS4 BT -->
  <inputConfig type="joystick" deviceName="Wireless Controller" deviceGUID="050000004c050000c405000000810000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="13">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="11" value="1" code="317" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="3" value="-1" code="3" />
    <input name="joystick2up" type="axis" id="4" value="-1" code="4" />
    <input name="l2" type="button" id="6" value="1" code="312" />
    <input name="l3" type="button" id="11" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="5" value="1" code="311" />
    <input name="pageup" type="button" id="4" value="1" code="310" />
    <input name="r2" type="button" id="7" value="1" code="313" />
    <input name="r3" type="button" id="12" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="314" />
    <input name="start" type="button" id="9" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="2" value="1" code="307" />
    <input name="y" type="button" id="3" value="1" code="308" />
  </inputConfig>
  <!-- Elan Turbo Pad -->
  <inputConfig type="joystick" deviceName="ELAN TURBO PAD" deviceGUID="03000000341a00000302000010010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="13">
    <input name="a" type="button" id="2" value="1" code="306" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="12" value="1" code="316" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="button" id="6" value="1" code="310" />
    <input name="l3" type="button" id="10" value="1" code="314" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="5" value="1" code="309" />
    <input name="pageup" type="button" id="4" value="1" code="308" />
    <input name="r2" type="button" id="7" value="1" code="311" />
    <input name="r3" type="button" id="11" value="1" code="315" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="312" />
    <input name="start" type="button" id="9" value="1" code="313" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="0" value="1" code="304" />
  </inputConfig>
  <!-- SN30 Pro BT -->
  <inputConfig type="joystick" deviceName="8Bitdo SN30 Pro" deviceGUID="05000000c82d00000161000000010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="13" value="1" code="317" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="button" id="8" value="1" code="312" />
    <input name="l3" type="button" id="13" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="7" value="1" code="311" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="r2" type="button" id="9" value="1" code="313" />
    <input name="r3" type="button" id="14" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- iNNEXT PAD USB -->
  <inputConfig type="joystick" deviceName="USB Gamepad " deviceGUID="03000000790000001100000010010000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="10">
    <input name="a" type="button" id="1" value="1" code="289" />
    <input name="b" type="button" id="2" value="1" code="290" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="8" value="1" code="296" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="5" value="1" code="293" />
    <input name="pageup" type="button" id="4" value="1" code="292" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="8" value="1" code="296" />
    <input name="start" type="button" id="9" value="1" code="297" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="0" value="1" code="288" />
    <input name="y" type="button" id="3" value="1" code="291" />
  </inputConfig>
  <!-- GameStop PS4 Fun USB -->
  <inputConfig type="joystick" deviceName="GameStop PS4 Fun Controller" deviceGUID="03000000c01100000140000011010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="14">
    <input name="a" type="button" id="2" value="1" code="306" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="10" value="1" code="314" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="5" value="-1" code="5" />
    <input name="l2" type="button" id="6" value="1" code="310" />
    <input name="l3" type="button" id="10" value="1" code="314" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="5" value="1" code="309" />
    <input name="pageup" type="button" id="4" value="1" code="308" />
    <input name="r2" type="button" id="7" value="1" code="311" />
    <input name="r3" type="button" id="11" value="1" code="315" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="312" />
    <input name="start" type="button" id="9" value="1" code="313" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="0" value="1" code="304" />
  </inputConfig>
  <!-- Logitech RumblePad USB -->
  <!-- Microsoft XBox 360 USB -->
  <inputConfig type="joystick" deviceName="Microsoft X-Box 360 pad" deviceGUID="030000005e0400008e02000014010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="13">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="10" value="1" code="316" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="3" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="4" />
    <input name="l2" type="button" id="6" value="1" code="312" />
    <input name="l3" type="button" id="11" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="5" value="1" code="311" />
    <input name="pageup" type="button" id="4" value="1" code="310" />
    <input name="r2" type="button" id="7" value="1" code="313" />
    <input name="r3" type="button" id="12" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="314" />
    <input name="start" type="button" id="9" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="308" />
    <input name="y" type="button" id="2" value="1" code="307" />
  </inputConfig>
  <!-- Microsoft XBox One USB -->
  <!-- Sony Interactive Entertainment Wireless Controller USB -->
  <!-- FireStorm Dual Power 2 USB -->
  <!-- XBox Original Pad V2 USB -->
  <!-- Mayflash USB to DB9 adapter -->
  <inputConfig type="joystick" deviceName="Mayflash limited Mayflash MD USB Adapter" deviceGUID="0300000079000000ae18000011010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="start" type="button" id="9" value="1" code="313" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="2" value="1" code="306" />
  </inputConfig>
  <!-- THRUSTMASTER FireStorm Dual Power 2 -->
  <inputConfig type="joystick" deviceName="THRUSTMASTER FireStorm Dual Power 2 " deviceGUID="030000004f04000004b3000010010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="12">
    <input name="a" type="button" id="2" value="1" code="306" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="8" value="1" code="312" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="5" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="6" />
    <input name="l2" type="button" id="5" value="1" code="309" />
    <input name="l3" type="button" id="10" value="1" code="314" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="6" value="1" code="310" />
    <input name="pageup" type="button" id="4" value="1" code="308" />
    <input name="r2" type="button" id="7" value="1" code="311" />
    <input name="r3" type="button" id="11" value="1" code="315" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="312" />
    <input name="start" type="button" id="9" value="1" code="313" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="307" />
    <input name="y" type="button" id="1" value="1" code="305" />
  </inputConfig>
    <!-- Microsoft Adaptative Pad -->
  <inputConfig type="joystick" deviceName="Generic X-Box pad" deviceGUID="030000005e0400000a0b000005040000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="13">
    <input name="a" type="button" id="0" value="1" code="304" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="8" value="1" code="314" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="3" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="4" />
    <input name="l2" type="button" id="6" value="1" code="312" />
    <input name="l3" type="button" id="11" value="1" code="317" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="5" value="1" code="311" />
    <input name="pageup" type="button" id="4" value="1" code="310" />
    <input name="r2" type="button" id="7" value="1" code="313" />
    <input name="r3" type="button" id="12" value="1" code="318" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="314" />
    <input name="start" type="button" id="9" value="1" code="315" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="2" value="1" code="307" />
    <input name="y" type="button" id="3" value="1" code="308" />
  </inputConfig>
  <!--  BSGPAC02 series Arcade pads -->
  <inputConfig type="joystick" deviceName="BSGPAC02 Series" deviceGUID="03000000d81d00000e00000010010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="13">
    <input name="a" type="button" id="1" value="1" code="305" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="8" value="1" code="312" />
    <input name="l2" type="button" id="7" value="1" code="311" />
    <input name="l3" type="button" id="10" value="1" code="314" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="2" value="1" code="306" />
    <input name="pageup" type="button" id="6" value="1" code="310" />
    <input name="r2" type="button" id="3" value="1" code="307" />
    <input name="r3" type="button" id="11" value="1" code="315" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="8" value="1" code="312" />
    <input name="start" type="button" id="9" value="1" code="313" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="5" value="1" code="309" />
    <input name="y" type="button" id="4" value="1" code="308" />
  </inputConfig>
  <!-- PS3 Clone pad -->
  <inputConfig type="joystick" deviceName="PS3/PC Gamepad" deviceGUID="03000000100800000300000010010000" deviceNbAxes="5" deviceNbHats="1" deviceNbButtons="12">
    <input name="a" type="button" id="2" value="1" code="290" />
    <input name="b" type="button" id="6" value="1" code="294" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="8" value="1" code="296" />
    <input name="l2" type="button" id="5" value="1" code="293" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="1" value="1" code="289" />
    <input name="pageup" type="button" id="0" value="1" code="288" />
    <input name="r2" type="button" id="7" value="1" code="295" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="8" value="1" code="296" />
    <input name="start" type="button" id="9" value="1" code="297" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="3" value="1" code="291" />
    <input name="y" type="button" id="4" value="1" code="292" />
  </inputConfig>
  <!-- Snakebyte idroid:con -->
  <inputConfig type="joystick" deviceName="idroid:con" deviceGUID="050000006964726f69643a636f6e0000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="12">
    <input name="a" type="button" id="2" value="1" code="290" />
    <input name="b" type="button" id="1" value="1" code="289" />
    <input name="down" type="hat" id="0" value="4" code="16" />
    <input name="hotkey" type="button" id="10" value="1" code="298" />
    <input name="joystick1left" type="axis" id="0" value="-1" code="0" />
    <input name="joystick1up" type="axis" id="1" value="-1" code="1" />
    <input name="joystick2left" type="axis" id="2" value="-1" code="2" />
    <input name="joystick2up" type="axis" id="3" value="-1" code="5" />
    <input name="l2" type="button" id="6" value="1" code="294" />
    <input name="l3" type="button" id="10" value="1" code="298" />
    <input name="left" type="hat" id="0" value="8" code="16" />
    <input name="pagedown" type="button" id="5" value="1" code="293" />
    <input name="pageup" type="button" id="4" value="1" code="292" />
    <input name="r2" type="button" id="7" value="1" code="295" />
    <input name="r3" type="button" id="11" value="1" code="299" />
    <input name="right" type="hat" id="0" value="2" code="16" />
    <input name="select" type="button" id="8" value="1" code="296" />
    <input name="start" type="button" id="9" value="1" code="297" />
    <input name="up" type="hat" id="0" value="1" code="16" />
    <input name="x" type="button" id="3" value="1" code="291" />
    <input name="y" type="button" id="0" value="1" code="288" />
  </inputConfig>
  <!-- xinmo 0003:16C0:05E1.0004 -->
  <inputConfig type="joystick" deviceName="Xin-Mo Xin-Mo Controller" deviceGUID="03000000c0160000e105000001010000" deviceNbAxes="4" deviceNbHats="1" deviceNbButtons="13">
    <input name="a" type="button" id="7" value="1" code="311" />
    <input name="b" type="button" id="0" value="1" code="304" />
    <input name="down" type="axis" id="1" value="-1" code="1" />
    <input name="hotkey" type="button" id="8" value="1" code="312" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="6" value="1" code="310" />
    <input name="pageup" type="button" id="1" value="1" code="305" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="8" value="1" code="312" />
    <input name="start" type="button" id="5" value="1" code="309" />
    <input name="up" type="axis" id="1" value="1" code="1" />
    <input name="x" type="button" id="2" value="1" code="306" />
    <input name="y" type="button" id="3" value="1" code="307" />
  </inputConfig>
  <!-- 8BitDo M30 gamepad -->
  <inputConfig type="joystick" deviceName="8BitDo M30 gamepad" deviceGUID="05000000c82d00005106000000010000" deviceNbAxes="6" deviceNbHats="1" deviceNbButtons="16">
    <input name="a" type="button" id="7" value="1" code="311" />
    <input name="b" type="button" id="1" value="1" code="305" />
    <input name="down" type="axis" id="1" value="1" code="1" />
    <input name="hotkey" type="button" id="2" value="1" code="306" />
    <input name="l2" type="button" id="8" value="1" code="312" />
    <input name="left" type="axis" id="0" value="-1" code="0" />
    <input name="pagedown" type="button" id="6" value="1" code="310" />
    <input name="pageup" type="button" id="3" value="1" code="307" />
    <input name="r2" type="button" id="9" value="1" code="313" />
    <input name="right" type="axis" id="0" value="1" code="0" />
    <input name="select" type="button" id="10" value="1" code="314" />
    <input name="start" type="button" id="11" value="1" code="315" />
    <input name="up" type="axis" id="1" value="-1" code="1" />
    <input name="x" type="button" id="4" value="1" code="308" />
    <input name="y" type="button" id="0" value="1" code="304" />
  </inputConfig>
  <inputConfig type="joystick" deviceName="GPIO Controller 1" deviceGUID="15000000010000000100000000010000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="9">
		<input name="a" type="button" id="0" value="1" code="304" />
		<input name="b" type="button" id="1" value="1" code="305" />
		<input name="down" type="axis" id="1" value="1" code="1" />
		<input name="hotkey" type="button" id="8" value="1" code="316" />
		<input name="left" type="axis" id="0" value="-1" code="0" />
		<input name="pagedown" type="button" id="5" value="1" code="311" />
		<input name="pageup" type="button" id="4" value="1" code="310" />
		<input name="right" type="axis" id="0" value="1" code="0" />
		<input name="select" type="button" id="6" value="1" code="314" />
		<input name="start" type="button" id="7" value="1" code="315" />
		<input name="up" type="axis" id="1" value="-1" code="1" />
		<input name="x" type="button" id="2" value="1" code="307" />
		<input name="y" type="button" id="3" value="1" code="308" />
	</inputConfig>
	<inputConfig type="joystick" deviceName="GPIO Controller 2" deviceGUID="15000000010000000200000000010000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="9">
		<input name="a" type="button" id="0" value="1" code="304" />
		<input name="b" type="button" id="1" value="1" code="305" />
		<input name="down" type="axis" id="1" value="1" code="1" />
		<input name="hotkey" type="button" id="8" value="1" code="316" />
		<input name="left" type="axis" id="0" value="-1" code="0" />
		<input name="pagedown" type="button" id="5" value="1" code="311" />
		<input name="pageup" type="button" id="4" value="1" code="310" />
		<input name="right" type="axis" id="0" value="1" code="0" />
		<input name="select" type="button" id="6" value="1" code="314" />
		<input name="start" type="button" id="7" value="1" code="315" />
		<input name="up" type="axis" id="1" value="-1" code="1" />
		<input name="x" type="button" id="2" value="1" code="307" />
		<input name="y" type="button" id="3" value="1" code="308" />
	</inputConfig>
	<inputConfig type="joystick" deviceName="GPIO Custom Controller 1" deviceGUID="15000000010000000500000000010000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="9">
		<input name="a" type="button" id="0" value="1" code="304" />
		<input name="b" type="button" id="1" value="1" code="305" />
		<input name="down" type="axis" id="1" value="1" code="1" />
		<input name="hotkey" type="button" id="8" value="1" code="316" />
		<input name="left" type="axis" id="0" value="-1" code="0" />
		<input name="pagedown" type="button" id="5" value="1" code="311" />
		<input name="pageup" type="button" id="4" value="1" code="310" />
		<input name="right" type="axis" id="0" value="1" code="0" />
		<input name="select" type="button" id="6" value="1" code="314" />
		<input name="start" type="button" id="7" value="1" code="315" />
		<input name="up" type="axis" id="1" value="-1" code="1" />
		<input name="x" type="button" id="2" value="1" code="307" />
		<input name="y" type="button" id="3" value="1" code="308" />
	</inputConfig>
	<inputConfig type="joystick" deviceName="GPIO Custom Controller 2" deviceGUID="15000000010000000600000000010000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="9">
		<input name="a" type="button" id="0" value="1" code="304" />
		<input name="b" type="button" id="1" value="1" code="305" />
		<input name="down" type="axis" id="1" value="1" code="1" />
		<input name="hotkey" type="button" id="8" value="1" code="316" />
		<input name="left" type="axis" id="0" value="-1" code="0" />
		<input name="pagedown" type="button" id="5" value="1" code="311" />
		<input name="pageup" type="button" id="4" value="1" code="310" />
		<input name="right" type="axis" id="0" value="1" code="0" />
		<input name="select" type="button" id="6" value="1" code="314" />
		<input name="start" type="button" id="7" value="1" code="315" />
		<input name="up" type="axis" id="1" value="-1" code="1" />
		<input name="x" type="button" id="2" value="1" code="307" />
		<input name="y" type="button" id="3" value="1" code="308" />
	</inputConfig>
	<inputConfig type="joystick" deviceName="MCP23017 Controller" deviceGUID="15000000010000000300000000010000" deviceNbAxes="2" deviceNbHats="0" deviceNbButtons="12">
		<input name="a" type="button" id="8" value="1" code="313" />
		<input name="b" type="button" id="4" value="1" code="309" />
		<input name="down" type="axis" id="1" value="-1" code="1" />
		<input name="hotkey" type="button" id="5" value="1" code="310" />
		<input name="left" type="axis" id="0" value="-1" code="0" />
		<input name="pagedown" type="button" id="11" value="1" code="316" />
		<input name="pageup" type="button" id="7" value="1" code="312" />
		<input name="right" type="axis" id="0" value="1" code="0" />
		<input name="select" type="button" id="9" value="1" code="314" />
		<input name="start" type="button" id="10" value="1" code="315" />
		<input name="up" type="axis" id="1" value="1" code="1" />
		<input name="x" type="button" id="1" value="1" code="305" />
		<input name="y" type="button" id="0" value="1" code="304" />
	</inputConfig>
</inputList>
